unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type

  TTipoOperacao = (opSub, opSoma, opMult, opDiv, opCls);

  TFrmCalc = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Button11: TButton;
    Button10: TButton;
    Button12: TButton;
    Button13: TButton;
    Button14: TButton;
    EDisplay: TEdit;
    Button15: TButton;
    Button16: TButton;
    procedure Button15Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button16Click(Sender: TObject);
    procedure EDisplayKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    TipoOp : TTipoOperacao;
    vlrOld : String;
    function Calcular: Currency;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmCalc: TFrmCalc;

implementation

{$R *.DFM}

function TFrmCalc.Calcular : Currency;
var
  _vlrold : currency;
  _vlrnew : currency;
begin
  Result:= 0;
  
  _vlrold:= StrToCurr( Trim( vlrOld ) );
  _vlrnew:= StrToCurr( Trim( EDisplay.Text ) );

  case TipoOp of
    opSub : begin
             result:= _vlrold - _vlrnew;
            end;
    opSoma: begin
             result:= _vlrold + _vlrnew;
            end;
    opMult: begin
             result:= _vlrold * _vlrnew;
            end;
    opDiv : begin
             result:= _vlrold / _vlrnew;
            end;
  end;
end;

procedure TFrmCalc.Button15Click(Sender: TObject);
begin
  if TipoOp = opCls then
    begin
      MessageDlg( 'Voc Selecionou o botao de limpar Calculadora!', mtWarning, [mbok], 0 );
      exit;
    end;
  EDisplay.Text:= CurrToStr( Calcular );
end;

procedure TFrmCalc.Button10Click(Sender: TObject);
begin
  TipoOp:= opSub;
  vlrOld:= EDisplay.Text;
  EDisplay.Clear;
end;

procedure TFrmCalc.Button12Click(Sender: TObject);
begin
  TipoOp:= opSoma;
  vlrOld:= EDisplay.Text;
  EDisplay.Clear;
end;

procedure TFrmCalc.Button13Click(Sender: TObject);
begin
  TipoOp:= opMult;
  vlrOld:= EDisplay.Text;
  EDisplay.Clear;
end;

procedure TFrmCalc.Button14Click(Sender: TObject);
begin
  TipoOp:= opDiv;
  vlrOld:= EDisplay.Text;
  EDisplay.Clear;
end;

procedure TFrmCalc.Button11Click(Sender: TObject);
begin
  EDisplay.Text:= EDisplay.Text + Trim( TButton( Sender ).Caption );
end;

procedure TFrmCalc.Button16Click(Sender: TObject);
begin
  TipoOp  := opCls;
  vlrOld  := '';
  EDisplay.Clear;
end;

procedure TFrmCalc.EDisplayKeyPress(Sender: TObject; var Key: Char);
begin
  if not( key in [ '0'..'9', #8, #27, ',' ] ) then
    key:= #0;
end;

procedure TFrmCalc.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
    begin
      Button15Click(Sender);
      key:= #0;
    end;
  case Key of
    '/' : begin
            TipoOp:= opDiv;
            vlrOld:= EDisplay.Text;
            EDisplay.Clear;
          end;
    '*' : begin
            TipoOp:= opMult;
            vlrOld:= EDisplay.Text;
            EDisplay.Clear;
          end;
    '-' : begin
            TipoOp:= opSub;
            vlrOld:= EDisplay.Text;
            EDisplay.Clear;
          end;
    '+' : begin
            TipoOp:= opSoma;
            vlrOld:= EDisplay.Text;
            EDisplay.Clear;
          end;
  end;
end;

procedure TFrmCalc.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_ESCAPE then
    begin
      TipoOp:= opCls;
      EDisplay.Clear;
    end;
end;

end.
